<mat-form-field class="dwfe-form-group-material" [formGroup]="group"
                [ngClass]="{ 'isFilled' : control.value,
                             'isChanged': markIfChanged && isChanged }"
                [appearance]="appearanceValue">

  <input matInput [formControlName]="'ctrl'"
         [type]="hideCharacters ? 'password' : 'text'"
         [errorStateMatcher]="matcher"
         [tabindex]="tabIndexValue">

  <mat-label>{{labelText}}</mat-label>

  <mat-hint align="start">{{hintText}}</mat-hint>

  <mat-error *ngIf="control.hasError('required')">
    {{app.i18n('required', i18n)}}
  </mat-error>
  <mat-error *ngIf="control.hasError('minlength')">
    {{app.i18n('length_err', i18n)}} >= {{minLength}}
  </mat-error>
  <mat-error *ngIf="!control.hasError('minlength') && control.hasError('atLeastOneNumber')">
    {{app.i18n('at_least_1_number', i18n)}}
  </mat-error>
  <mat-error *ngIf="!control.hasError('minlength') && control.hasError('atLeastOneLetter')">
    {{app.i18n('at_least_1_letter', i18n)}}
  </mat-error>
  <mat-error *ngIf="control.hasError('maxlength')">
    {{app.i18n('length_err', i18n)}} <= {{maxLength}}
  </mat-error>

  <div matSuffix *ngIf="hideCharacters && control.enabled">
    <svg class="dwfe-icon-visible" (click)="switchHide()"
         width="24" height="20" viewBox="0 0 24 20" xmlns="http://www.w3.org/2000/svg">
      <path d="M22.17 9.92s-4.48 6-10 6-10-6-10-6 4.48-6 10-6 10 6 10 6z"></path>
      <circle cx="12.17" cy="9.92" r="2.58"></circle>
    </svg>
  </div>

  <div matSuffix *ngIf="!hideCharacters && control.enabled">
    <svg class="dwfe-icon-visible" (click)="switchHide()"
         width="24" height="20" viewBox="0 0 24 20" xmlns="http://www.w3.org/2000/svg">
      <path d="M22.17 9.92s-4.48 6-10 6-10-6-10-6 4.48-6 10-6 10 6 10 6z"></path>
      <circle cx="12.17" cy="9.92" r="2.58"></circle>
      <path class="icon-cross-bar" d="M20.67 1.42l-17 17"></path>
    </svg>
  </div>

  <dwfe-form-control-clear class="dwfe-icon-clear-field  dwfe-icon-clear-field--password"
                           [control]="control"></dwfe-form-control-clear>

</mat-form-field>
